/* main driver for btree-based text retreival system
   modified by Frank Andrasco 1990
*/
#include <stdio.h>
#include "def.h"

/* modified by Sanjay, Oct 2000, Commented
   out options "b","d"; added new option T 
   for inorder traversal
*/
/* modified by christos, Nov. 23 '91 */
/* this array containts the (growing) sizes of the
   postings records */

long LISTSIZE[100];

extern FILE *fpbtree, *fppost, *fptext;
int btWriteCount=0,	/* number of writes on B-tree */
    btReadCount=0,	/* number of reads on B-tree */
    pWriteCount=0,	/* number of writes on postings */
    pReadCount=0;	/* number of reads on postings */
int iCount=0;		/* number of inserted words */
int sqCount=0;		/* number of successful queries */
int uqCount=0;		/* number of unsucc. queries */



main () {
    char    word[MAXWORDSIZE],low[MAXWORDSIZE], high[MAXWORDSIZE];
    char    cmd[MAXWORDSIZE];		/* string to hold a command */
    char    fname[MAXWORDSIZE];		/* name of input file */
    PAGENO	i;
    int goOn;
    int printKey(), printOcc();
    double dist;

    setparms();	/* reads the pagesize and the number of ptrs/postigs_record */
    dbopen();	/* opens or creates the three files (btree, postings, text) */

    goOn = TRUE;
    while( goOn) {
        printf("\n*** These are your commands .........\n");
	 printf("\"P\" to scan the tree\n");
	 printf("\"i\" to insert\n");
	 printf("\"p\" to print a btree page\n");
	 printf("\"s\" to search, and print the key\n");
        printf("\"S\" to search, and print the key, posting list pairs\n");
        printf("\"T\" to print the btree in inorder format\n");
        printf("\"A\" to print all the pairs within a given distance\n");
	 printf("\"a\" to print the count of the pairs within a given distance\n");
	 printf("\"R\" to print the keys within a given range\n");
	 printf("\"r\" to print the count of keys within a given range\n");

        printf("\"x\" to exit\n");
        /* printf("\"d\" to display statistics, \"c\" to clear them,\n"); */
        scanf("%s", cmd);
        switch( cmd[0]) {
 
	 case 'R':
            printf("enter 1st word: ");
            scanf("%s", low);
            printf("enter 2nd word: ");
            scanf("%s", high);
            printf("\n*** Finding keys within range from %s to %s \n",low, high);
            printf("!!!! Please Implement Me !!!!\n");
	     break;
	 case 'r':
            printf("enter 1st word: ");
            scanf("%s", low);
            printf("enter 2nd word: ");
            scanf("%s", high);
            printf("\n*** Finding the count of keys within range from %s to %s \n",low, high);
            printf("!!!! Please Implement Me !!!!\n");
	     break;
        case 'A':
            printf("enter epsilon-distance: ");
            scanf("%lf", &dist);
	     printf("\n*** Finding all pairs within distance %lf: \n", dist);
	     printf("!!!! Please Implement Me !!!!\n");
	     break;
        case 'a':
            printf("enter epsilon-distance: ");
            scanf("%lf", &dist);
	     printf("\n*** Finding the count of all pairs within distance %lf: \n", dist);
	     printf("!!!! Please Implement Me !!!!\n");
	     break;
        case 'P':
            printf("\n*** Scanning... \n");
            scanTree(printOcc);
            break;
        case 'i':
            printf("give input file name: ");
            scanf("%s", fname);
            printf("\n*** Inserting %s\n", fname);
            insert(fname);
            break;
        case 's':
            printf("enter search-word: ");
            scanf("%s", word);
			printf("\n*** Searching for word %s \n", word);
            search(word, FALSE);
            break;
  	 case 'S':
            printf("enter search-word: ");
            scanf("%s", word);
			printf("\n*** Searching for word %s \n", word);
            search(word, TRUE);
            break;
        case 'p':
            printf("pagenumber=?\n");
            scanf("%s", cmd);
            i = (PAGENO) atoi(cmd);
            printPage(i,fpbtree);
            break;
        case 'T':
            printf("\n*** Printing tree in order .........\n");
            PrintTreeInOrder(ROOT,0);
            break;
        case 'x':
            printf("\n*** Exiting .........\n");
            goOn = FALSE;
            break;
        default:
            printf("\n*** Illegal command \"%s\"\n", cmd);
            break;
        }
    }

    dbclose();
    return(0);
    /* PrintTree();  */
}
